XIncludeFile "WIA-Wrapper.pbi"

InitWIA()

DeviceID.s = OpenWIASelectDeviceDialog(#WIA_ScannerDeviceType) ;Warning: The Dialog opens only if there is a device! Nothing happens without an device

Debug "DeviceID: " + DeviceID.s

If ConnectWIADevice(DeviceID.s)
  
  Debug "DeviceName: " + GetWIADeviceName()
  
  ;{ We examine some properties. You don't need to do that everytime, it's just for that example
  ExamineWIADeviceProperties() ;If you Examine a already connected Device, you will get some more informations than before, e.g. max. Resolutions and Bed Size of an Scanner
  While NextWIADeviceProperty()
    Debug "DevicePropertyID: " + Str(GetWIADevicePropertyID())
    Debug "DevicePropertyName: " + GetWIADevicePropertyName()
    Select GetWIADevicePropertyType()
      Case #WIA_BooleanPropertyType To #WIA_DoublePropertyType
        Debug "DevicePropertyInteger: " + Str(GetWIADevicePropertyInteger())
      Case #WIA_StringPropertyType
        Debug "DevicePropertyString: " + GetWIADevicePropertyString()
    EndSelect
  Wend
  ;}
  
  
  ; We need to create an Item. An WIA-Item is an Object that contains all setting 
  ; (e.g. Scanresolution Or Scanarea) and after the action the picturedata. 
  ; An Item represents an function of an Device, so a scanner has only one item.
    
  If ExamineWIAItems()
    Debug "ItemID: " + NextWIAItem() ;We select the first Item
    
    If ExamineWIAItemProperties() ;Examine all Properties. This also returns the number of properties available
      While NextWIAItemProperty()
        
        Debug "ItemPropertyID: " + Str(GetWIAItemPropertyID())
        Debug "ItemPropertyName: " + GetWIAItemPropertyName()
        Debug "ItemPropertyType: " + Str(GetWIAItemPropertyType())
        
        Select GetWIAItemPropertyType()
          Case #WIA_BooleanPropertyType To #WIA_DoublePropertyType ;We have numeric values
            Debug "ItemPropertyInteger: " + Str(GetWIAItemPropertyInteger())
          Case #WIA_StringPropertyType ;We have a string value
            Debug "ItemPropertyString: " + GetWIAItemPropertyString()
          Case #WIA_ClassIDPropertyType ;We have a ClassID, look in the WIA-Wrapper.pbi to get constants and there meaning
            Debug "ItemPropertyClassID: " + GetWIAItemPropertyString()
        EndSelect
        
        ;We set some properties
        Select GetWIAItemPropertyID()
          Case #WIA_PropertyID_HorizontalResolution
            SetWIAItemProperty("300")
          Case #WIA_PropertyID_VerticalResolution
            SetWIAItemProperty("300")
          Case #WIA_PropertyID_VerticalExtent
            SetWIAItemProperty("800")
          Case #WIA_PropertyID_HorizontalExtent
            SetWIAItemProperty("400")
        EndSelect
        
      Wend
      
      TransferWIAImage()
      
      SaveWIAFile("test.bmp")
      
    EndIf
    
  EndIf
  
EndIf

; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 57
; FirstLine = 24
; Folding = -
; EnableXP